var carousel = document.querySelector('.carousel');
var carouselContent = document.querySelector('.carousel-content');
var slides = document.querySelectorAll('.slide');
var arrayOfSlides = Array.prototype.slice.call(slides);
var carouselDisplaying;
var screenSize;
setScreenSize();
var lengthOfSlide;

function addClone() {
    var lastSlide = carouselContent.lastElementChild.cloneNode(true);
    lastSlide.style.left = (-lengthOfSlide) + "px";
    carouselContent.insertBefore(lastSlide, carouselContent.firstChild);
}
// addClone();

function removeClone() {
    var firstSlide = carouselContent.firstElementChild;
    firstSlide.parentNode.removeChild(firstSlide);
}

function moveSlidesRight() {
    var slides = document.querySelectorAll('.slide');
    var slidesArray = Array.prototype.slice.call(slides);
    var width = 0;

    slidesArray.forEach(function (el, i) {
        el.style.left = width + "px";
        width += lengthOfSlide;
    });
    addClone();
}
moveSlidesRight();

function moveSlidesLeft() {
    var slides = document.querySelectorAll('.slide');
    var slidesArray = Array.prototype.slice.call(slides);
    slidesArray = slidesArray.reverse();
    var maxWidth = (slidesArray.length - 1) * lengthOfSlide;

    slidesArray.forEach(function (el, i) {
        maxWidth -= lengthOfSlide;
        el.style.left = maxWidth + "px";
    });
}

window.addEventListener('resize', setScreenSize);

function setScreenSize() {
    if (window.innerWidth >= 700) {
        carouselDisplaying = 4;
    } else if (window.innerWidth >= 600) {
        carouselDisplaying = 2;
    } else {
        carouselDisplaying = 2;
    }
    getScreenSize();
}

function getScreenSize() {
    var slides = document.querySelectorAll('.slide');
    var slidesArray = Array.prototype.slice.call(slides);
    lengthOfSlide = (carousel.offsetWidth / carouselDisplaying);
    var initialWidth = -lengthOfSlide;
    slidesArray.forEach(function (el) {
        el.style.width = lengthOfSlide + "px";
        el.style.left = initialWidth + "px";
        initialWidth += lengthOfSlide;
    });
}


var rightNav = document.querySelector('.nav-right');
rightNav.addEventListener('click', moveLeft);

var moving = true;
function moveRight() {
    if (moving) {
        moving = false;
        var lastSlide = carouselContent.lastElementChild;
        lastSlide.parentNode.removeChild(lastSlide);
        carouselContent.insertBefore(lastSlide, carouselContent.firstChild);
        removeClone();
        var firstSlide = carouselContent.firstElementChild;
        firstSlide.addEventListener('transitionend', activateAgain);
        moveSlidesRight();
    }
}

function activateAgain() {
    var firstSlide = carouselContent.firstElementChild;
    moving = true;
    firstSlide.removeEventListener('transitionend', activateAgain);
}

var leftNav = document.querySelector('.nav-left');
leftNav.addEventListener('click', moveRight);

// var moveLeftAgain = true;

function moveLeft() {
    if (moving) {
        moving = false;
        removeClone();
        var firstSlide = carouselContent.firstElementChild;
        firstSlide.addEventListener('transitionend', replaceToEnd);
        moveSlidesLeft();
    }
}

function replaceToEnd() {
    var firstSlide = carouselContent.firstElementChild;
    firstSlide.parentNode.removeChild(firstSlide);
    carouselContent.appendChild(firstSlide);
    firstSlide.style.left = ((arrayOfSlides.length - 1) * lengthOfSlide) + "px";
    addClone();
    moving = true;
    firstSlide.removeEventListener('transitionend', replaceToEnd);
}




carouselContent.addEventListener('mousedown', seeMovement);

var initialX;
var initialPos;
function seeMovement(e) {
    initialX = e.clientX;
    getInitialPos();
    carouselContent.addEventListener('mousemove', slightMove);
    document.addEventListener('mouseup', moveBasedOnMouse);
}

function slightMove(e) {
    if (moving) {
        var movingX = e.clientX;
        var difference = initialX - movingX;
        if (Math.abs(difference) < (lengthOfSlide / 4)) {
            slightMoveSlides(difference);
        }
    }
}

function getInitialPos() {
    var slides = document.querySelectorAll('.slide');
    var slidesArray = Array.prototype.slice.call(slides);
    initialPos = [];
    slidesArray.forEach(function (el) {
        var left = Math.floor(parseInt(el.style.left.slice(0, -2)));
        initialPos.push(left);
    });
}

function slightMoveSlides(newX) {
    var slides = document.querySelectorAll('.slide');
    var slidesArray = Array.prototype.slice.call(slides);
    slidesArray.forEach(function (el, i) {
        var oldLeft = initialPos[i];
        el.style.left = (oldLeft + newX) + "px";
    });
}

function moveBasedOnMouse(e) {
    var finalX = e.clientX;
    if (initialX - finalX > 0) {
        moveRight();
    } else if (initialX - finalX < 0) {
        moveLeft();
    }
    document.removeEventListener('mouseup', moveBasedOnMouse);
    carouselContent.removeEventListener('mousemove', slightMove);
}



/**Funcion para acordeon**/
//this is the button
var acc = document.getElementsByClassName("course-accordion");
var i;

for (i = 0; i < acc.length; i++) {
    //when one of the buttons are clicked run this function
    acc[i].onclick = function () {
        //variables
        var panel = this.nextElementSibling;
        var coursePanel = document.getElementsByClassName("course-panel");
        var courseAccordion = document.getElementsByClassName("course-accordion");
        var courseAccordionActive = document.getElementsByClassName("course-accordion active");

        /*if pannel is already open - minimize*/
        if (panel.style.maxHeight) {
            //minifies current pannel if already open
            panel.style.maxHeight = null;
            //removes the 'active' class as toggle didnt work on browsers minus chrome
            this.classList.remove("active");
        } else { //pannel isnt open...
            //goes through the buttons and removes the 'active' css (+ and -)
            for (var ii = 0; ii < courseAccordionActive.length; ii++) {
                courseAccordionActive[ii].classList.remove("active");
            }
            //Goes through and removes 'activ' from the css, also minifies any 'panels' that might be open
            for (var iii = 0; iii < coursePanel.length; iii++) {
                this.classList.remove("active");
                coursePanel[iii].style.maxHeight = null;
            }
            //opens the specified pannel
            panel.style.maxHeight = panel.scrollHeight + "px";
            //adds the 'active' addition to the css.
            this.classList.add("active");
        }
    }//closing to the acc onclick function
}//closing to the for loop.




/***Slide para docentes */

var slideIndex = 1;
showSlides(slideIndex);

function plusSlides(n) {
    showSlides(slideIndex += n);
}

function currentSlide(n) {
    showSlides(slideIndex = n);
}

function showSlides(n) {
    var i;
    var slides = document.getElementsByClassName("mySlides");
    var dots = document.getElementsByClassName("dot");
    if (n > slides.length) { slideIndex = 1 }
    if (n < 1) { slideIndex = slides.length }
    for (i = 0; i < slides.length; i++) {
        slides[i].style.display = "none";
    }
    for (i = 0; i < dots.length; i++) {
        dots[i].className = dots[i].className.replace(" active", "");
    }
    slides[slideIndex - 1].style.display = "block";
    dots[slideIndex - 1].className += " active";
}




/***Funcion para modals***/
const modalLinks = document.querySelectorAll('a[href^="#modal"]');

modalLinks.forEach(function (modalLink, index) {
    // console.log(modalLink.getAttribute('href'));
    const modalId = modalLink.getAttribute('href');
    modalLink.addEventListener('click', function (event) {

        const modal = document.querySelector(modalId);
        if (modal) {
            const closeBtn = modal.querySelector('.dialog__close');
            // console.log(modal.getAttribute('id'));
            event.preventDefault();
            modal.showModal();

            closeBtn.addEventListener('click', function (event) {
                // console.log('clicked');
                modal.close();
            });

            document.addEventListener('click', function (event) {

                const dialogEl = event.target.tagName;
                const dialogElId = event.target.getAttribute('id');
                // Log the clicked element in the console
                // console.log(dialogEl);
                if (dialogEl == 'DIALOG') {
                    // console.log(dialogEl);
                    modal.close();
                }

            }, false);

        } else {
            console.log('Modal doesn\'t exist');
        }
    });
});



/***Funcion para los slide desde movil**/
let slideIndexdos = 1;
showSlidesdos(slideIndexdos);

function plusSlidesdos(n) {
  showSlidesdos(slideIndexdos += n);
}

function currentSlidedos(n) {
  showSlidesdos(slideIndexdos = n);
}

function showSlidesdos(n) {
  let i;
  let slidesdos = document.getElementsByClassName("mySlidesdos");
  let dotdoss = document.getElementsByClassName("dotdos");
  if (n > slidesdos.length) { slideIndexdos = 1 }
  if (n < 1) { slideIndexdos = slidesdos.length }
  for (i = 0; i < slidesdos.length; i++) {
    slidesdos[i].style.display = "none";
  }
  for (i = 0; i < dotdoss.length; i++) {
    dotdoss[i].className = dotdoss[i].className.replace(" active", "");
  }
  slidesdos[slideIndexdos - 1].style.display = "block";
  dotdoss[slideIndexdos - 1].className += " active";
}




/**Pintar formulario**/

function cambiarColor(){

    console.log(document.getElementById('cont_form'),'Tiny');
    document.getElementById('cont_form').classList.remove('contenedor_formulario');
    document.getElementById('cont_form').classList.add('contenedor_formulario_on', 'animate__animated', 'animate__headShake');
    setTimeout(() => {
        document.getElementById('cont_form').classList.add('contenedor_formulario');
        document.getElementById('cont_form').classList.remove('contenedor_formulario_on', 'animate__animated', 'animate__headShake');
      }, "3000")
    console.log("cambio de color");
}



/*Funcion de apertura*/
window.onload = function(){
    var acor1 = document.getElementById("accordeon1");
    acor1.click();
}



/**
 * Funcion del slide de testimonios
 * **/

var slideIndextest = 1;
showSlidestest(slideIndextest);

function plusSlidestest(n) {
    showSlidestest(slideIndextest += n);
}

function currentSlidetest(n) {
    showSlidestest(slideIndextest = n);
}

function showSlidestest(n) {
    var i;
    var slidestest = document.getElementsByClassName("mySlidestest");
    var dotstest = document.getElementsByClassName("dottest");
    if (n > slidestest.length) { slideIndextest = 1 }
    if (n < 1) { slideIndextest = slidestest.length }
    for (i = 0; i < slidestest.length; i++) {
        slidestest[i].style.display = "none";
    }
    for (i = 0; i < dotstest.length; i++) {
        dotstest[i].className = dotstest[i].className.replace(" activetest", "");
    }
    slidestest[slideIndextest - 1].style.display = "block";
    dotstest[slideIndextest - 1].className += " activetest";
}



/***/
/**Pintar formulario**/

function cambiarColor(){

    console.log(document.getElementById('cont_form'),'Tiny');
    document.getElementById('cont_form').classList.remove('contenedor_formulario');
    document.getElementById('cont_form').classList.add('contenedor_formulario_on', 'animate__animated', 'animate__headShake');
    setTimeout(() => {
        document.getElementById('cont_form').classList.add('contenedor_formulario');
        document.getElementById('cont_form').classList.remove('contenedor_formulario_on', 'animate__animated', 'animate__headShake');
      }, "3000")
    console.log("cambio de color");
}